module Unification (
  UP,
  unify
  ) where
import CoreFP

type UP = [(Type, Type)]

unify :: UP -> TSub
unify eqs = unfy [] eqs
  where
    unfy mgu []       = mgu
    unfy mgu (eq:eqs) = unfy (mgu' `tcomp` mgu) (e
      ++ map (\(l, r) -> (l `tsub` mgu', r `tsub` mgu')) eqs)
      where (e, mgu') = step eq
    step (s,t) | s == t                  = ([], [])
    step (TVar x, t)                     = singletonSub x t
    step (t, TVar x)                     = singletonSub x t
    step (TFun s1 t1, TFun s2 t2)        = ([(s1,s2), (t1,t2)], [])
    step (TCon g ss, TCon f ts) | g == f = (zip ss ts, [])
    step _                               = notUnif
    notUnif          = error "not unifiable"
    singletonSub x t = if x `elem` tvars t then notUnif else ([], [(x,t)])
